/*****************************************************************

Most Basic USART (RS232 Serial) Communication Support File.
Simple reading and writing of data without using
Interrupts.

BAUD RATE:57600 Bits per Second
CRYSTAL Frequency: 20MHz

Target Chip: PIC18F4520
Target Compiler: HI-TECH C For PIC18 (http://www.htsoft.com/)
Project: MPLAP Project File

Copyright (c) 2008-2010
eXtreme Electronics, India
www.eXtremeElectronics.co.in

*****************************************************************/
#include "p18f26k22.h"

//#include "htc.h"

//#include "usart.h"
/*void USARTInit();

void USARTWriteByte(char);

void USARTWriteString(char *);

void USARTWriteLine(char *);

void USARTWriteInt(int ,unsigned char);

unsigned char USARTReadByte();*/

void USARTInit() {
	//Baud Rate = 9600 Bits per Second
	//*** Note: Valid On 16MHz Crystal ONLY ***
	//For other crystal freq calculate new values for SPBRG
	SPBRG1=25;

	//TXSTA REG
	TXSTA1bits.TXEN=1;
	TXSTA1bits.BRGH=0;
	
	//RCSTA
	RCSTA1bits.SPEN=1;
	RCSTA1bits.CREN=1;	//Enable Receiver (RX)
	
	//BAUDCON
	BAUD1CONbits.BRG16=0;
}

void USARTWriteByte(char ch)
{
	//Wait for TXREG Buffer to become available
	while(!PIR1bits.TXIF);

	//Write data
	TX1REG=ch;
}

void USARTWriteString(char *str)
{
	while((*str)!='\0')
	{
		//Wait for TXREG Buffer to become available
		while(!PIR1bits.TXIF);

		//Write data
		TX1REG=(*str);

		//Next goto char
		str++;
	}
}

/*

Writes a line of text to USART and goes to new line
The new line is Windows style CR/LF pair.

This will work on Hyper Terminal Only NOT on Linux

*/

void USARTWriteLine(char *ln){
	USARTWriteString(ln);
	//USARTWriteString("\r\n");
}

void USARTWriteInt(int val,unsigned char field_length)
{
char str[5]={0,0,0,0,0};
int i=4,j=0;
	if(val<0) 
	{
		USARTWriteByte('-');	//Write '-' sign for negative numbers.
		val=(val*(-1));				//Make it positive.
	}

	//Convert Number To String and pump over Tx Channel.
	while(val)
	{
		str[i]=val%10;
		val=val/10;
		i--;
	}
	if(field_length>5)
		while(str[j]==0) j++;
	else
		j=5-field_length;
	
	for(i=j;i<5;i++)
	{
		USARTWriteByte('0'+str[i]);
	}
}


unsigned char USARTReadByte()
{
	while(!PIR1bits.RCIF);	//Wait for a byte
	
	return RC1REG;
}
